package com.algomagic.atn;

import att.grappa.GrappaConstants;

public interface VisualizationConstants extends GrappaConstants {
    public static final String SYSTEM_PREFIX = "atnvis.";

    public static final String CONFIG_FILE_PROP = SYSTEM_PREFIX + "ConfigFile";
    public static final String WINDOW_TITLE_PROP = SYSTEM_PREFIX + "window.Title";
    public static final String WINDOW_HEIGHT_PROP = SYSTEM_PREFIX + "window.Height";
    public static final String WINDOW_WIDTH_PROP = SYSTEM_PREFIX + "window.Width";

    public static final String DELAY_PROP = SYSTEM_PREFIX + "defaultDelay";
    public static final String LOOP_PROP = SYSTEM_PREFIX + "loop";

    public static final String PARSER_PROP = SYSTEM_PREFIX + "parser";
    public static final String PARSER_DEFAULT = "com.algomagic.atn.NullParser";
    
    public static final String SCALE_PROP = SYSTEM_PREFIX + "graph.Scale";
    public static final String SCALE_DEFAULT = "1.0";

    public static final String IGNOREPROC_PROP = SYSTEM_PREFIX + "parser.IgnoreProcessing";
    public static final String IGNOREPROC_DEFAULT = "true";


    public static final String SHADOW_PROP = SYSTEM_PREFIX + "graph.ShadowColor";
    public static final String SHADOW_DEFAULT = "grey90";


    public static final String CONFIG_FILE_DEFAULT = "atnvis.properties";
    public static final String WINDOW_TITLE_DEFAULT = "ATN Visualization";
    public static final String WINDOW_HEIGHT_DEFAULT = "800";
    public static final String WINDOW_WIDTH_DEFAULT = "600";

    public static final String DELAY_DEFAULT = "500";
    public static final String LOOP_DEFAULT = "true";

    public static final int LEFT_SIDE = 0;
    public static final int RIGHT_SIDE = 1;

    public static final String OPPONENT_PROC = "Opponent";
    public static final String VERIFIER_PROC = "Verifier";
    public static final String FULLY_PROC = "Fully";
    public static final String NOT_PROC = "Unprocessed";

    public static final String SATISFIED = "Satisfied";
    public static final String NOT_SATISFIED = "Failed";
    public static final String UNKNOWN = "Unknown";

    public static final String STANDARD_TARGET = "StandardTarget";
    public static final String ROLE_TARGET = "RoleTarget";
    public static final String LINKING_ROLE_TARGET = "LinkingRoleTarget";
    public static final String TRIVIAL_TARGET = "TrivialTarget";
    public static final String INTERSECTION_TARGET = "IntersectionTarget";
    public static final String LINKING_GOAL = "LinkingGoal";

    public static final String IMPLICATION_EDGE = "Implication";
    public static final String LINKING_MONITOR_EDGE = "LinkingMonitor";
    public static final String LINKING_SOLUTION_EDGE = "LinkingSolution";
    public static final String LINKING_IMPLICATION_EDGE = "LinkingImplication";
    public static final String INTERSECTION_EDGE = "Intersection";
    public static final String CONTROL_EDGE = "Control";

    public static final String DEFAULT_NODE = SYSTEM_PREFIX + "node.Default.";
    public static final String DEFAULT_EDGE = SYSTEM_PREFIX + "edge.Default.";


    public static final String[] NODE_ATTRS = {
	SHAPE_ATTR,
	SIDES_ATTR,
	PERIPHERIES_ATTR,
	STYLE_ATTR,
	COLOR_ATTR,
	FONTNAME_ATTR,
	FONTCOLOR_ATTR,
	FONTSIZE_ATTR,
	FONTSTYLE_ATTR };



    public static final String[] NODE_ATTRS_PROP = {
	"shape",
	"sides",
	"peripheries",
	"style",
	"color",
	"fontname",
	"fontcolor",
	"fontsize",
	"fontstyle" };

    public static final boolean[] NODE_ATTRS_INT = {
	false,
	true,
	true,
	false,
	false,
	false,
	false,
	true,
	false };


    public static final String[] EDGE_ATTRS = {
	STYLE_ATTR,
	COLOR_ATTR,
	DIR_ATTR };

    public static final String[] EDGE_ATTRS_PROP = {
	"style",
	"color",
	"direction" };


    public static final boolean[] EDGE_ATTRS_INT = {
	false,
	false,
	false };

}
